; Source des commandes sonores prédéfinies, adaptées en Ram, version Atmos
; André Chéramy (c) 2020
; V0621-1208
		org $9800		; Adresse d'implantation sous-programme + data
PSG01P	EQU $F590		; Envoie le param X dans le registre A du PSG 
PSG14P	EQU $FA86		; Envoie au PSG les 14 param situés à l'adresse XY 
; Source de la commande PING #9800
PING	LDX #LOW PARA1	; LL adr des 14 paramètres
		LDY #HIGH PARA1	; HH adr des 14 paramètres
		JMP PSG14P		
PARA1	DB	$18, $00, $00, $00, $00, $00, $00
		DB	$3E, $10, $00, $00, $00, $0F, $00
; Source de la commande SHOOT #9815
SHOOT	LDX #LOW PARA2	; LL adr des 14 paramètres
		LDY #HIGH PARA2	; HH adr des 14 paramètres
		JMP PSG14P		
PARA2	DB	$00, $00, $00, $00, $00, $00, $0F
		DB	$07, $10, $10, $10, $00, $08, $00
; Source de la commande EXPLODE #982A
EXPLODE	LDX #LOW PARA3	; LL adr des 14 paramètres
		LDY #HIGH PARA3	; HH adr des 14 paramètres
		JMP PSG14P		
PARA3	DB	$00, $00, $00, $00, $00, $00, $1F
		DB	$07, $10, $10, $10, $00, $18, $00
; Source de la commande TOUCON (clic des touches contrôles) #983F
TOUCON	LDX #LOW PARA4	; LL adr des 14 paramètres
		LDY #HIGH PARA4	; HH adr des 14 paramètres
		JMP PSG14P		
PARA4	DB	$2F, $00, $00, $00, $00, $00, $00
		DB	$3E, $10, $00, $00, $1F, $00, $00
; Source de la commande TOUNOR (clic des touches normales) #9854
TOUNOR	LDX #LOW PARA5	; LL adr des 14 paramètres
		LDY #HIGH PARA5	; HH adr des 14 paramètres
		JMP PSG14P		
PARA5	DB	$1F, $00, $00, $00, $00, $00, $00
		DB	$3E, $10, $00, $00, $1F, $00, $00
; Source de la commande ZAP #9869
ZAP		LDX #LOW PARA6	; LL adr des 14 paramètres
		LDY #HIGH PARA6	; HH adr des 14 paramètres
		JSR PSG14P
; Début de la temporisation
		SEI		
		LDA #$00		; Période nulle = fréquence infinie
		TAX 	
BOUCL2	TXA
		PHA				; Sauve période sur la pile
		LDA	#$00		; Registre R0 du PSG (LL période canal 1
		JSR PSG01P		; Envoie période X dans le registre R0 du PSG
		LDX #$00		; Temporisation
BOUCL1	DEX
		BNE BOUCL1		; Environ 1,3 ms
		PLA				; Récupère période
		TAX				; dans X
		INX				; Incrémente la période = la fréquence diminue
		CPX	#$70		; a t-on atteint 554 Hz (DO# octave 4)?
		BNE BOUCL2		; Non, on reboucle
		CLI
; Fin de la temporisation		
		LDA #$08		; Oui indexe registre 8 du PSG (volume du canal 1)
		LDX #$00		; Volume sonore nul
		JMP PSG01P		; Envoie au PSG
PARA6	DB	$00, $00, $00, $00, $00, $00, $00
		DB	$3E, $0F, $00, $00, $00, $00, $00
; Source de la commande OUPS #989B
OUPS	LDX #LOW PARAM	; LL adr des 14 paramètres
		LDY #HIGH PARAM	; HH adr des 14 paramètres
		JSR PSG14P		
; Début de la temporisation
		SEI		
		LDY #$60		; Temporisation boucle externe
		LDX #$00		; Temporisation boucle interne
BOUCL3	DEX
		BNE BOUCL3
		DEY
		BNE BOUCL3		; Delai de 1s
		CLI
; Fin de la temporisation		
		LDA #$07		; Registre 7 du PSG : contrôle des canaux
		LDX #$3F		; 0011 1111 tous inactivés
		JMP PSG01P
PARAM	DB	$46, $00, $00, $00, $00, $00, $00
		DB	$3E, $0F, $00, $00, $BD, $28, $02
FIN
