; Source de la commande ZAPLM en Ram, version Atmos
; André Chéramy (c) 2020
; V0621-1208
		org $9800		; Adresse d'implantation sous-programme + data
PSG01P	EQU $F590		; Envoie le param X dans le registre A du PSG 
PSG14P	EQU $FA86		; Envoie au PSG les 14 param situés à l'adresse XY 
ZAP		LDX #LOW PARAM	; LL, octet de poids faible de adr des 14 paramètres
		LDY #HIGH PARAM	; HH, octet de poids fort de adr des 14 paramètres
		JSR PSG14P
LLINIT	LDA #$00		; Octet de poids faible de la période initiale
		TAX
BOUCL2	TXA				; Copie la période en cours dans le registre A
		PHA				; Sauve cette période sur la pile (reste aussi dans X)
		LDA #$00		; A indexe le registre R0 du PSG
		JSR PSG01P		; Envoie période X dans registre du PSG pointé par A
; Début de la temporisation
		SEI
		LDX #$00		; 256 tours pour la boucle interne X
BOUCL1	DEX
		BNE BOUCL1		; Environ 1,28 ms pour la boucle interne X
		CLI
; Fin de la temporisation
		PLA				; Récupère la période en cours
		TAX				; La copie dans X
		INX				; Et l'incrémente
LLFIN	CPX #$70		; A-t-on atteint la période limite (octet faible)?
		BNE BOUCL2		; Non, on reboucle
		LDA #$08		; Oui, indexe registre 8 du PSG (volume du canal 1)
		LDX #$00		; Volume sonore nul
		JMP PSG01P		; Envoie 0 dans le registre du PSG pointé par A
PARAM	DB $00, $00, $00, $00, $00, $00, $00
		DB $3E, $0F, $00, $00, $00, $00, $00
FIN
